#include "StdAfx.h"
#include "BorderShapeScriptletPlugin.h"
#include "ScriptletConstant.h"
#include "BorderShape.h"
#include "XMLUtil.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_BORDERSHAPE_NODE, CBorderShapeScriptletPlugin);
CBorderShapeScriptletPlugin::CBorderShapeScriptletPlugin(void)
{
}

CBorderShapeScriptletPlugin::~CBorderShapeScriptletPlugin(void)
{
}
BOOL CBorderShapeScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CBorderShape* pBorderShape = reinterpret_cast<CBorderShape*>(pTarget);
		if (pBorderShape == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		USES_CONVERSION;

		//thickness
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_THICKNESS_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsSubAttr(pNode, CT2CA(SCRIPTLET_THICKNESS_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			RECT rcThickness = {0};
			CString strThickness = szValue;
			int nToken = 0;
			rcThickness.left = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
			rcThickness.top = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
			rcThickness.right = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));
			rcThickness.bottom = _ttoi(strThickness.Tokenize(SCRIPTLET_SEPARATOR, nToken));

			pBorderShape->SetBorderDepth(&rcThickness);
		}
		//bordercolor
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_BORDERCOLOR_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsSubAttr(pNode, CT2CA(SCRIPTLET_BORDERCOLOR_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			COLORREF clrBack = XMLUtil::ColorFromString(szValue);
			pBorderShape->SetBorderColor(clrBack);
		}
		//incolor
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_INCOLOR_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsSubAttr(pNode, CT2CA(SCRIPTLET_INCOLOR_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			COLORREF clrInner = XMLUtil::ColorFromString(szValue);
			pBorderShape->SetInnerColor(clrInner);
		}
	}
	return bSuccess;
}
CComponent* CBorderShapeScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CBorderShape;
	return pComponent;
}
